<?xml version="1.0" encoding="utf-8"?>
<odoo>

    <record id="hr_work_entry_action_view_gantt" model="ir.actions.act_window.view">
        <field name="sequence" eval="2"/>
        <field name="view_mode">gantt</field>
        <field name="act_window_id" ref="hr_work_entry.hr_work_entry_action"/>
    </record>

    <record id="hr_work_entry_action_conflict_view_gantt" model="ir.actions.act_window.view">
        <field name="sequence" eval="2"/>
        <field name="view_mode">gantt</field>
        <field name="act_window_id" ref="hr_work_entry.hr_work_entry_action_conflict"/>
    </record>

    <record id="payroll_hr_work_entry_view_calendar_inherit" model="ir.ui.view">
        <field name="name">payroll.hr.work.entry.view.calendar.inherit</field>
        <field name="model">hr.work.entry</field>
        <field name="inherit_id" ref="hr_work_entry.hr_work_entry_view_calendar"/>
        <field name="arch" type="xml">
            <xpath expr="//calendar" position="attributes">
                <attribute name="js_class">work_entries_calendar</attribute>
            </xpath>
        </field>
    </record>

    <record id="hr_work_entry_gantt" model="ir.ui.view">
        <field name="name">hr.work.entry.gantt</field>
        <field name="model">hr.work.entry</field>
        <field name="arch" type="xml">
            <gantt js_class="work_entries_gantt"
                   string="Work Entries"
                   date_start="date_start"
                   date_stop="date_stop"
                   color="color"
                   default_group_by='employee_id'
                   decoration-secondary="state == 'validated'"
                   decoration-warning="state == 'conflict'"
                   progress="name"
                   scales="day,week,month"
                   precision="{'day': 'hour:quarter', 'week': 'day:half', 'month': 'day:full'}"
                   create="0"
                   plan="0">
                <field name="color" invisible="1"/>
                <field name="state"/>
                <field name="employee_id"/>
                <field name="name"/>
            </gantt>
        </field>
    </record>

    <record id="payroll_hr_work_entry_view_form_inherit" model="ir.ui.view">
        <field name="name">payroll.hr.work.entry.view.form.inherit</field>
        <field name="model">hr.work.entry</field>
        <field name="inherit_id" ref="hr_work_entry.hr_work_entry_view_form"/>
        <field name="arch" type="xml">
            <xpath expr="//sheet" position="before">
                <div attrs="{'invisible': [('state', '!=', 'conflict')]}">
                    <div class="alert alert-warning mb-0" role="alert" attrs="{'invisible': ['!', ('work_entry_type_id', '=', False)]}">
                        This work entry cannot be validated. The work entry type is undefined.
                    </div>
                    <div attrs="{'invisible': [('work_entry_type_id', '=', False)]}">
                        <div class="alert alert-warning mb-0" role="alert" attrs="{'invisible': [('leave_id', '=', False)]}">
                            This work entry cannot be validated. There is a leave to approve (or refuse) at the same time.
                        </div>
                        <div class="alert alert-warning mb-0" role="alert" attrs="{'invisible': ['!', ('leave_id', '=', False)]}">
                            This work entry cannot be validated. It is conflicting with at least one work entry. <br/>
                            Two work entries of the same employee cannot overlap at the same time.
                        </div>
                    </div>
                </div>
            </xpath>
            <xpath expr="//field[@name='state']" position="before">
                <field name="leave_state" invisible="1"/>
                <button string="Refuse Time Off" name="action_refuse_leave" type="object" attrs="{'invisible': ['|', '|', ('state', '!=', 'conflict'), ('leave_id', '=', False)]}"/>
                <button string="Approve Time Off" name="action_approve_leave" type="object" attrs="{'invisible': ['|', '|', ('state', '!=', 'conflict'), ('leave_state', '=', 'validate')]}"/>
            </xpath>
            <xpath expr="//field[@name='work_entry_type_id']" position="after">
                <field name="leave_id" attrs="{'invisible': [('leave_id', '=', False)]}"/>
            </xpath>
        </field>
    </record>

    <record id="payroll_hr_work_entry_type_view_form_inherit" model="ir.ui.view">
        <field name="name">payroll.hr.work.entry.type.view.form.inherit</field>
        <field name="model">hr.work.entry.type</field>
        <field name="inherit_id" ref="hr_work_entry.hr_work_entry_type_view_form"/>
        <field name="arch" type="xml">
            <xpath expr="//group[@name='identification']" position="after">
                <group>
                    <field name="is_leave"/>
                    <field name="is_unforeseen"/>
                    <field name="leave_type_ids" widget="many2many_tags" attrs="{'invisible': [('is_leave', '=', False)]}"/>
                </group>
            </xpath>
            <xpath expr="//group[@name='main_group']" position="after">
                <group string="Display in Payslip">
                    <group>
                        <field name="round_days"/>
                        <field name="round_days_type" attrs="{'invisible': [('round_days', '=', 'NO')]}"/>
                    </group>
                </group>
            </xpath>
        </field>
    </record>

    <record model="ir.actions.server" id="action_generate_payslips_from_work_entries">
        <field name="name">Generate payslips</field>
        <field name="model_id" ref="model_hr_payslip_employees"/>
        <field name="binding_model_id" ref="model_hr_payslip_employees"/>
        <field name="state">code</field>
        <field name="code">
            action = env['hr.payslip.employees'].create({}).compute_sheet()
        </field>
    </record>

</odoo>
